/*
 * i386/freebsd2/jit-md.h
 * FreeBSD i386 JIT configuration information.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __i386_freebsd2_jit_md_h
#define __i386_freebsd2_jit_md_h

/**/
/* Include common information. */
/**/
#include "i386/jit.h"

/**/
/* Extra exception handling information. */
/**/

/* Function prototype for signal handlers */
#define	EXCEPTIONPROTO							\
	int sig, siginfo_t *si, struct sigcontext* ctx

/* Get the first exception frame from a signal handler */
#define	EXCEPTIONFRAME(f, c)						\
	(f).retbp = (c)->sc_ebp;					\
	(f).retpc = (c)->sc_eip + 1

/* Get the stack pointer out of the signal handler context. */
#define EXCEPTIONSP(c) (c)->sc_esp

/* Get the frame pointer out of the signal handler context. */
#define EXCEPTIONBP(c) (c)->sc_ebp

/* Initialize an exceptionFrame from a frame pointer. */
#define EXCEPTION_TOP_FRAME(f, bp) \
do { \
	(f)->retbp = (uintp)bp; \
	(f)->retpc = 0; \
} while(0)

/* Switch a signal context to an alternate stack and pc. */
#define EXCEPTION_ALT_FRAME(ctx, new_pc, new_sp) \
do { \
	(ctx)->sc_pc = (int)(new_pc); \
	(ctx)->sc_sp = (int)(new_sp); \
} while(0)

/* Jthreads uses guard pages. */
#if defined(HAVE_MMAP) && defined(UNIX_JTHREADS2)
#undef STACK_LIMIT
#endif

#endif
