/*
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this file
 * for any purpose with or without restriction is hereby granted.
 */

import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.TeamHandle;

import edu.utah.janosvm.resources.MemorySpec;
import edu.utah.janosvm.resources.ResourceSpec;
import edu.utah.janosvm.resources.StrideCPUSpec;
import edu.utah.janosvm.resources.MemoryResource;

import edu.utah.janosvm.kit.management.team.CPUMonitor;

public class ResourceControl
    implements Runnable
{
    public void run()
    {
	/* Consume CPU */
	for( ;; );
    }
    
    public static void main(String args[])
	throws Throwable
    {
	TeamHandle th, hi, lo;

	/** Memory example. **/
	
	/* Create a team with a small amount of memory. */
	th = Team.create(new ResourceSpec[] {
	    new MemorySpec(512 * 1024),
	});

	th.switchTo();
	{
	    System.err.println("Child memory: " + MemoryResource.getMax());
	}
	th.returnFrom();
	th.terminate();
	

	/** CPU example. **/
	
	/* Create a team with a relatively large number of CPU tickets. */
	hi = Team.create("CPU Muncher Hi", new ResourceSpec[] {
	    new StrideCPUSpec(500),
	});
	
	/* Create a team with a relatively small number of CPU tickets. */
	lo = Team.create("CPU Muncher Lo", new ResourceSpec[] {
	    new StrideCPUSpec(100),
	});

	/*
	 * Switch to the teams and start a thread that will eat up all of their
	 * CPU time.
	 */
	
	lo.switchTo();
	{
	    new Thread(new ResourceControl()).start();
	}
	lo.returnFrom();
	
	hi.switchTo();
	{
	    new Thread(new ResourceControl()).start();
	}
	hi.returnFrom();

	/*
	 * Start up the CPUMonitor thread so we can monitor the CPU usage of
	 * hi and lo.
	 */
	CPUMonitor.main(new String[] {
	    "CPU Muncher Hi",
	    "CPU Muncher Lo",
	    "kernel",
	});
    }
}
