/*
 * jskedResource-inline.h
 * Inline functions for the jsked resource
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#ifndef _jsked_resource_inline_h
#define _jsked_resource_inline_h

#if defined(UNIX_JTHREADS2)

/*
 * Get the jsked for a given team.
 */
KAFFE_INLINE
jsked *teamJsked(struct _jteam *jt)
{
	jskedResourceClient *jrc;
	jsked *retval;
	
	jrc = (jskedResourceClient*)
		getTeamInternalResource(jt, &metalJskedResource.link);
	retval = jrc->js;

	return( retval );
}
/*
 * Get the jsked for the current team.
 */
KAFFE_INLINE
jsked *currentJsked(void)
{
	jsked *retval;

	retval = teamJsked(0);
	
	ensure(retval != 0);
	
	return( retval );
}

#endif

#endif /* _jsked_resource_inline_h */
