/*
 * jdk_compat.c
 * Implementation of jdk compatibility.
 *
 * Copyright (c) 2002 University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Contributed by the Flux Research Group, Department of Computer Science,
 * University of Utah, http://www.cs.utah.edu/flux/
 */

#include <string.h>

#include "jdk_compat.h"

jdkCompat jdk_compat_data = {
	JDK_COMPAT_1_3,
};

char *jdkCompatNames[] = {
	"jdk1.0",
	"jdk1.1",

	"jdk1.2",
	"jdk1.3",
	"jdk1.4",
};

int setJDKCompatibility(char *id)
{
	int lpc, retval = 0;

	for( lpc = 0; (lpc < JDK_COMPAT_MAX) && !retval; lpc++ )
	{
		if( !strcasecmp(id, jdkCompatNames[lpc]) )
		{
			jdk_compat_data.version = lpc;
			retval = 1;
		}
	}
	return( retval );
}
