/*
 * jdk_compat.h
 * Header file for jdk compatibility.
 *
 * Copyright (c) 2002 University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Contributed by the Flux Research Group, Department of Computer Science,
 * University of Utah, http://www.cs.utah.edu/flux/
 */

#ifndef _jdk_compat_h
#define _jdk_compat_h

/*
 * The compatibility modes.
 */
typedef enum {
	JDK_COMPAT_1_0,
	JDK_COMPAT_1_1,
	
	JDK_COMPAT_1_2,
	JDK_COMPAT_1_3,
	JDK_COMPAT_1_4,

	JDK_COMPAT_MAX
} jdk_compat_type_t;

/*
 * Set the JDK compatibility mode based on the given string.
 *
 * id - A string representing the compatibility mode (e.g. jdk1.3).
 * returns - True if the value of id was understood.
 */
int setJDKCompatibility(char *id);

/*
 * The mapping of valid compatibility names.
 */
extern char *jdkCompatNames[JDK_COMPAT_MAX];

/*
 * Global JDK compatibility data.
 *
 * version - The current compatibility mode.
 */
typedef struct _jdkCompat {
	jdk_compat_type_t version;
} jdkCompat;

extern jdkCompat jdk_compat_data;

#endif
