/*
 * Copyright (c) 1999, 2000, 2002 The University of Utah.  All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file.
 *
 * Contributed by the Flux Research Group at the University of Utah.
 * Authors: Godmar Back, Leigh Stoller, Patrick Tullmann
 */

#ifndef anjthread_create_inline_h
#define anjthread_create_inline_h

#include "anjthread_inline.h"

#include "anjthread_types.h"
#include "anjthread_types_priv.h"
#include "anjthread_intr.h"
#include "gc.h"

ANJTHREAD_INLINE void
anjthread_reenter_kaffe(jthread_t tid)
{
	require(tid);
	require(tid == jthread_current());
	require(tid->status == JTHREAD_STATUS_INNODEOS);

	/* XXX Needs to be set on create */
	an_thread_sethandler(_jthread_intr_handler);
	tid->flags |= JTHREAD_FLAG_INSTALLED_HANDLER;
        tid->status = JTHREAD_STATUS_RUNNING;
	/*
	 * A slaughtered partial thread can still come back and execute code
	 * so we need to catch that and exit immediately.
	 */
	if( tid->flags & JTHREAD_FLAG_CAGED )
		an_thread_exit();
}

ANJTHREAD_INLINE void
anjthread_leave_kaffe(jthread_t tid)
{
	require(tid);
	require(tid == jthread_current());
	require(tid->status == JTHREAD_STATUS_RUNNING);
	
        tid->status = JTHREAD_STATUS_INNODEOS;
}

#endif /* anjthread_create_inline_h */
