/*
 * jcpuAccounting.h
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdio.h>

#include "assert_pp.h"

#include "jcpuAccounting.h"

void jcpuAccountingPrint(FILE *file, jcpuAccount *jca)
{
	require(file != 0);
	require(jca != 0);
	
	fprintf(file,
		"jcpuAccount(%p)[jca_Parent=%p; "
		"jca_StartUsed=%qu; "
		"jca_TotalUsed=%qu ms; "
		"jca_Birth=%qu ms; "
		"jca_Death=%qu ms]",
		jca,
		jca->jca_Parent,
		jca->jca_StartUsed,
		jcpuConvertTime(JCPU_TIME_MS, jca->jca_TotalUsed),
		jcpuConvertTime(JCPU_TIME_MS, jca->jca_Birth),
		jcpuConvertTime(JCPU_TIME_MS, jca->jca_Death));
}
