/*
 * jcpuEvent.c
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdio.h>

#include "assert_pp.h"

#include "jcpuEvent.h"

static
char *jcpuEventTypeNames[JCPU_EVENT_MAX] = {
	0,
	"KERNEL_TRAP",
	"DEBUG_TRAP",
	"RESET",
	"NULL_POINTER",
	"ARITHMETIC",
	"TIMER",
	"PREEMPT",
	"IO",
	"CHILD",
};

void jcpuEventPrint(FILE *file, jcpuEvent *jce)
{
	require((sizeof(jcpuEventTypeNames) / sizeof(char *))
		== (JCPU_EVENT_MAX + 1));

	require(file != 0);
	require(jce != 0);
	require(jce->jce_Type > JCPU_EVENT_MIN);
	require(jce->jce_Type < JCPU_EVENT_MAX);
	
	fprintf(file,
		"jcpuEvent(%p)[jce_Next=%p; jce_Type=%s]",
		jce,
		jce->jce_Next,
		jcpuEventTypeNames[jce->jce_Type]);
}
