/*
 * jioAccounting.c
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include "jioAccounting.h"

void jioAccountingInit(jioAccount *jia)
{
	int lpc;
	
	require(jia != 0);

	for( lpc = 0; lpc < JIO_ACCOUNT_MAX; lpc++ )
	{
		jia->jia_Accumulator[lpc] = 0;
	}
}

void jioAccountingKill(jioAccount *jia)
{
	require(jia != 0);
}

void jioAccountingPrint(FILE *file, jioAccount *jia)
{
	require(file != 0);
	require(jia != 0);

	fprintf(file,
		"jioAccount(%p)[jia_Accumulator={ "
		"%qd, "
		"%qd }]",
		jia,
		jia->jia_Accumulator[JIO_ACCOUNT_IN],
		jia->jia_Accumulator[JIO_ACCOUNT_OUT]);
}
