/*
 * jmesssage.c
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include "jmessage.h"

void jmessagePrint(FILE *file, jmessage *jm)
{
	require(file != 0);
	require(jm != 0);

	fprintf(file,
		"jmessage(%p)[jm_Flags=%lx; "
		"jm_ReplyPort=%p]",
		jm,
		jm->jm_Flags,
		jm->jm_ReplyPort);
}

void jmessagePortPrint(FILE *file, jmessagePort *jmp)
{
	jmessage *jm;
	
	require(file != 0);
	require(jmp != 0);

	fprintf(file,
		"jmessagePort(%p)[jmp_Messages={ ",
		jmp);
	jm = (jmessage *)jmp->jmp_Messages.lh_Head;
	while( jm->jm_Link.ln_Succ )
	{
		jmessagePrint(file, jm);
		fprintf(file, " ");
		jm = (jmessage *)jm->jm_Link.ln_Succ;
	}
	fprintf(file,
		"}; "
		"jmp_Thread=%p; "
		"jmp_SignalNumber=%d]",
		jmp->jmp_Thread,
		jmp->jmp_SignalNumber);
}
