/*
 * jmutex.c
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include "assert_pp.h"

#include "jmutex.h"

void jmutex_initialise(jmutex *jm)
{
	require(jm != 0);
	
	jm->jm_Holder = 0;
	jm->jm_Waiters = 0;
}

void jmutex_destroy(jmutex *jm)
{
	require(jm != 0);
	require(jm->jm_Holder == 0);
	require(jm->jm_Waiters == 0);
}

void jcondvar_initialise(jcondvar *jcv)
{
	require(jcv != 0);

	jcv->jcv_Waiters = 0;
}

void jcondvar_destroy(jcondvar *jcv)
{
	require(jcv != 0);
	require(jcv->jcv_Waiters == 0);
}
