/*
 * kfile.c
 *
 * Copyright (c) 2001, 2003 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include "config.h"
#include "kfile.h"
#include <sys/types.h>
#include "jsyscall.h"
#include "jthread.h"

static
int kreadfn(void *cookie, char *data, int length)
{
	int fd = (int)cookie;
	int rc, retval = -1;

	rc = KREAD(fd, data, length, &retval);
	return( retval );
}

static
int kwritefn(void *cookie, const char *data, int length)
{
	int fd = (int)cookie;
	int rc, retval = -1;

	rc = KWRITE(fd, data, length, &retval);
	return( retval );
}

static
off_t kseekfn(void *cookie, off_t pos, int whence)
{
	int fd = (int)cookie;
	off_t retval = -1;
	int rc;

	rc = KLSEEK(fd, pos, whence, &retval);
	return( retval );
}

static
int kclosefn(void *cookie)
{
	int fd = (int)cookie;
	int rc, retval = 0;

	rc = KCLOSE(fd);
	return( retval );
}


FILE *kfdopen(int fd, const char *mode)
{
	FILE *retval = NULL;

#if 0
	retval = funopen((void *)fd,
			 ((mode[0] == 'r') ||
			  (mode[1] == '+')) ? kreadfn : NULL,
			 ((mode[0] == 'w') ||
			  (mode[1] == '+') ||
			  (mode[1] == 'a')) ? kwritefn : NULL,
			 kseekfn,
			 kclosefn);
#endif
	return( retval );
}
