/*
 * kpath.h
 *
 * Copyright (c) 2003 University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Contributed by the Flux Research Group, Department of Computer Science,
 * University of Utah, http://www.cs.utah.edu/flux/
 */

#ifndef __kpath_h
#define __kpath_h

#include <janosvm/listNode.h>

#include "stringParsing.h"

typedef struct _pathEntry {
	struct lnMinNode pe_Link;
	char *pe_Path;
} pathEntry;

int kpAddParsedPath(struct lnMinList *list, parsedString *paths);
int kpAddPath(struct lnMinList *list, char *paths);
pathEntry *kpFindParsedPath(struct lnMinList *list, parsedString *path);
pathEntry *kpFindPath(struct lnMinList *list, char *path);

const char *file_part(const char *filename);
parsedString dir_part(const char *filename);
int absolute_path(const char *filename);

#endif
