/*
 * CPUResource.java
 * Provides java level access to a team's CPU resource.
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.resources;

/**
 * Provides java level access to the current team's CPU resource.
 */
public final class CPUResource
{
    /**
     * @param cs The new CPUSpec for this team.
     */
    public static native void change(CPUSpec cs)
	throws ResourceSpecException;
    
    /**
     * @return The CPU usage for the current team.  There are no defined units
     * for the value.
     */
    public static native long getUsage();

    /**
     * @return The total idle time for the VM.
     */
    public static native long getIdle();
    
    /**
     * Its a static only class.
     */
    private CPUResource()
    {
    }
}
