/*
 * Event.java
 * Base class for events.
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.sys;

/**
 * Simple base class for events used by the kernel.
 *
 * @see EventHandler
 * @see EventQueue
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
/*package*/ class Event
    extends ListNode
{
    /**
     * The target object for this event.
     */
    private EventHandler target;

    /**
     * The type of event.
     */
    protected int event;

    /**
     * @param eh The target object for this event.
     */
    /*package*/ void setTarget(EventHandler eh)
    {
	this.target = eh;
    }
    
    /**
     * @return The target object for this event.
     */
    /*package*/ EventHandler getTarget()
    {
	return this.target;
    }
    
    /**
     * @param value The event number.
     */
    /*package*/ void setEvent(int value)
    {
	this.event = value;
    }

    /**
     * @return The event number.
     */
    public int getEvent()
    {
	return this.event;
    }

    public String toString()
    {
	return "Event[target="
	    + this.target
	    + "; event="
	    + this.event
	    + "]";
    }
}
