/*
 * CloneFactory.java
 *
 * Copyright (c) 2000, 2003 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package java.lang;

public class CloneFactory
{

    public static String clone(String s)
    {
	return (String)s.clone();
    }

    public static Throwable clone(Throwable th)
    {
	try
	{
	    return (Throwable)th.clone();
	}
	catch(CloneNotSupportedException cnse)
	{
	    return null;
	}
    }

    public static Object clone(Object o)
	throws CloneNotSupportedException
    {
	Object retval = null;
		
	if( o != null )
	{
	    retval = o.clone();
	}
	return retval;
    }

    public static native Object copy(Object o);
}
