/*
 * cat.java
 *
 * Copyright (c) 2001,2003 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, distribute, and sell this file for
 * any purpose is hereby granted without fee, provided that the above
 * copyright notice is maintained.
 */

package edu.utah.janosvm.apps;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;
//import java.nio.ByteBuffer;
//import java.nio.channels.Channels;
//import java.nio.channels.FileChannel;
//import java.nio.channels.WritableByteChannel;
//import java.nio.channels.ReadableByteChannel;

/**
 * cat.  Java version of the unix 'cat' command.
 *
 * @author Patrick Tullmann, University of Utah &lt;<a href="mailto:tullmann@cs.utah.edu">tullmann@cs.utah.edu</a>&gt;
 */
public class cat
{
    private static void error(String msg)
    {
	System.err.println("cat: " +msg);
    }

    private static void dumpFile(File f)
    {
	if (!f.exists())
	{
	    System.err.println(f.getName() + ": No such file or directory");
	    return;
	}
		
	if (f.isDirectory())
	{
	    System.err.println(f.getName() + ": Is a directory");
	    return;
	}

	try
	{
	    //newio_cat(f);
	    oldio_cat(f);

	}
	catch (IOException ioe)
	{
	    System.err.println("With file " +f.getName()+ " got exception: " +ioe);
	}
    }

    private static void newio_cat(File f)
	throws IOException
    {
//	ByteBuffer buf = ByteBuffer.allocate(8 * 1024);
//	ReadableByteChannel in = new FileInputStream(f).getChannel();
//	WritableByteChannel out = Channels.newChannel(System.out);
//	int rc = 0;
//	
//	while (rc != -1)
//	{
//	    rc = in.read(buf);
//	    if (rc > 0)
//		out.write(buf);
//	}
    }
    
    private static void oldio_cat(File f)
	throws IOException
    {
	byte[] buf = new byte[8 * 1024];
	InputStream is = new FileInputStream(f);
	OutputStream os = System.out;
	int rc = 0;

	while (rc != -1)
	{
	    rc = is.read(buf, 0, buf.length);
	    if (rc > 0)
		os.write(buf, 0, rc);
	}
    }

    public static void main(String[] args)
    {
	if (args == null || args.length == 0)
	{
	    error("Please provide some file(s) to cat");
	    // does not return;
	}
	
	for( int i = 0; i < args.length; i++ )
	{
	    File f = new File(args[i]);

	    System.out.println("dump file " + f);
	    dumpFile(f);
	}
    }
}
