/*
 * ls.java
 *
 * Copyright (c) 2001,2003 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, distribute, and sell this file for
 * any purpose is hereby granted without fee, provided that the above
 * copyright notice is maintained.
 */

package edu.utah.janosvm.apps;

import java.io.File;

/**
 * ls.  Java version of the unix 'ls' command.
 *
 * @author Patrick Tullmann, University of Utah &lt;<a href="mailto:tullmann@cs.utah.edu">tullmann@cs.utah.edu</a>&gt;
 */
public class ls
{
    private static void error(String msg)
    {
	System.err.println("ls: " +msg);
	System.exit(-1);
    }

    private static void printFile(File f)
    {
	System.out.println(f.getName());
    }

    public static void main(String[] args)
    {
	String fname = ".";
	if (args.length > 0)
	    fname = args[0];

	File f = new File(fname);
	if (!f.exists())
	{
	    error(fname+ ": No such file or directory.");
	    // doesn't return
	}
		
	if (f.isFile())
	    printFile(f);
	else
	{
	    String[] files = f.list();
			
	    for (int i = 0; i < files.length; i++)
	    {
		File ent = new File(files[i]);
		printFile(ent);
	    }
	}
    }
}
