/*
 * NativePlexChannel.java
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.kit.comm.jsi;

import java.io.IOException;

public final class NativePlexChannel
    implements JSIChannel
{
    static native void bindNativeClass();

    static {
	NativePlexChannel.bindNativeClass();
	NativePlexProvider.bindNativeClass();
    }
    
    private native void init(String protocol) throws IOException;
    
    public NativePlexChannel(String protocol)
	throws IOException
    {
	this.init(protocol);
    }

    public synchronized native void sendMessage(byte msg[]) throws IOException;

    public synchronized native void replyMessage(byte msg[])
	throws IOException;

    public synchronized native byte[] recvMessage() throws IOException;
    
    public synchronized native void disconnect();

    protected void finalize()
    {
	this.disconnect();
    }
    
    public String toString()
    {
	return "NativePlexChannel["
	    + "]";
    }
}
