/*
 * NativePlexProvider.java
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.kit.comm.jsi;

import java.io.IOException;

public final class NativePlexProvider
    implements JSIProvider
{
    static native void bindNativeClass();

    static {
	NativePlexChannel.bindNativeClass();
	NativePlexProvider.bindNativeClass();
    }
    
    private native void init(String protocol) throws IOException;
    
    public NativePlexProvider(String protocol)
	throws IOException
    {
	this.init(protocol);
    }

    public native void handle(JSIConnectionHandler jch);

    public native void detach();
    
    protected void finalize()
    {
	this.detach();
    }
    
    public String toString()
    {
	return "NativePlexProvider["
	    + "]";
    }
}
