/*
 * Assert.java
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package java.lang.isolate;

/*package*/ class Assert
{
  /*package*/ static class Error
		extends java.lang.RuntimeException
  {
    Error()
    {
      super("Assert failure. Hope the backtrace helps.");
    }

    Error(String msg)
    {
      super("Assert failure: " +msg);
    }
  }

  static void requireLock(Object obj)
  {
//    if (!Thread.holdsLock(obj))
//      throw new Assert.Error("Current thread does not hold lock on: " +obj);
  }

  static void requireLock(Object obj, String msg)
  {
//    if (!Thread.holdsLock(obj))
//      throw new Assert.Error("Current thread does not hold lock on: " +obj+ ": " +msg);
  }

  static void require(boolean test)
  {
    if (!test)
      throw new Assert.Error();
  }
  
  static void require(boolean test, String msg)
  {
    if (!test)
      throw new Assert.Error(msg);
  }
  
  static void ensure(boolean test)
  {
    if (!test)
      throw new Assert.Error();
  }

  static void ensure(boolean test, String msg)
  {
    if (!test)
      throw new Assert.Error(msg);
  }
}
