/*
 * EventLink_Unattached.java
 *
 * Copyright (c) 2002,2003 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package java.lang.isolate;

/*package*/ class EventLink_Unattached
  extends EventLink 
{ 
  private final String msg = "Current isolate is not receiver on this EventLink";

  /*package*/ EventLink_Unattached(Isolate target, Isolate receiver, String name)
  {
    super(target, receiver, name);
    Assert.require(target != null);
    Assert.require(receiver != null);
    Assert.require(!Isolate.currentIsolate().equals(receiver));
  }

  public void close() 
    throws IllegalStateException
  {
    throw new IllegalStateException(msg);
  }
  
  public boolean isOpen() 
    throws IllegalStateException
  {
    throw new IllegalStateException(msg);
  }
  
  public IsolateEvent receiveEvent(long millis, int nanos)
    throws IllegalStateException
  {
    throw new IllegalStateException(msg);
  }
}
