/*
 * OneWayLink_Neither.java
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package java.lang.isolate;

import edu.utah.janosvm.sys.TeamHandle;

/*package*/ class OneWayLink_Neither
      	extends OneWayLink
{
  private static final String exceptionMsg = "Neither sender nor receiver on this link.";

  /*package*/ OneWayLink_Neither(Isolate sender, Isolate receiver, String name)
    throws ClosedLinkException
  {
    super(sender, receiver, name);
    Assert.require(! sender.equals(Isolate.currentIsolate()));
    Assert.require(! receiver.equals(Isolate.currentIsolate()));
  }

  public boolean isOpen()
    throws IllegalStateException
  {
    throw new IllegalStateException(exceptionMsg);
  }

  public void close()
    throws IllegalStateException
  {
    throw new IllegalStateException(exceptionMsg);
  }

  public boolean send(IsolateMessage x, long millis, int nanos)
    throws IllegalStateException
  {
    throw new IllegalStateException(exceptionMsg);
  }

  public IsolateMessage receive(long millis, int nanos)
    throws IllegalStateException
  {
    throw new IllegalStateException(exceptionMsg);
  }

} // end Neither
