#
# Copyright (c) 2003 The University of Utah and the Flux Group.
# All rights reserved.
# 
# This file is part of the JanosVM documentation.
# 
# Permission to use, copy, modify, distribute, and sell this
# documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice(s) appear in all copies.
#
# Author: Tim Stack
#

from janosvm import *

class Proxies:
    def __init__(self, jvm):
        self.jvm = jvm;
        self.jvm.msg.pushSpecifier("proxies")

    def create(self, provider, destination):
        self.jvm.msg.setWhat(JSI_CREATE_PROPERTY)
        self.jvm.msg.add("provider", provider)
        self.jvm.msg.add("destination", destination)
        reply = self.jvm.send()
        return string.atoi(reply.find("result"))
    
    def list(self):
        self.jvm.msg.setWhat(JSI_LIST_PROPERTIES)
        reply = self.jvm.send()
        count = reply.identifierCount("id")
        lpc = 0
        retval = []
        while lpc < count:
            retval.append((reply.find("id", lpc),
                           reply.find("provider", lpc),
                           reply.find("destination", lpc)))
            lpc = lpc +1
        return retval

    
