#
# Copyright (c) 2003 The University of Utah and the Flux Group.
# All rights reserved.
# 
# This file is part of the JanosVM documentation.
# 
# Permission to use, copy, modify, distribute, and sell this
# documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice(s) appear in all copies.
#
# Author: Tim Stack
#

import os

DEFAULT_SYSTEM_ROOT = "/etc"
HOME_DIRECTORY_ROOT = ".janosvm"
HOME_DIRECTORY_REGISTRY = "/registry"

class Registry:
    def __init__(self, home = ""):
        if home != "":
            self.path = home
        elif os.environ.has_key("HOME"):
            self.path = (os.environ["HOME"] +
                         "/" +
                         HOME_DIRECTORY_ROOT +
                         HOME_DIRECTORY_REGISTRY)
        else:
            self.path = DEFAULT_SYSTEM_ROOT + HOME_DIRECTORY_REGISTRY


    def getPath(self, name, sub, create = 0):
        retval = self.path + "/" + name
        if create:
            try:
                os.mkdir(retval)
            except:
                pass
        if sub != "":
            retval = retval + "/" + sub
        return retval

    def registerName(self, name):
        self.getPath(name, "", 1)

    def unregisterName(self, name):
        return

    def registerExport(self, name, export, data):
        exportPath = self.getPath(name, export, 1)
        file = open(exportPath, "w+")
        file.write(data)
        file.close()

    def unregisterExport(self, name, export):
        exportPath = self.getPath(name, export)
        os.remove(exportPath)

    def findExport(self, name, export):
        exportPath = self.getPath(name, export)
        file = open(exportPath)
        retval = file.read()
        file.close()
        return retval
