
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.TeamHandle;

import edu.utah.janosvm.resources.StdioSpec;
import edu.utah.janosvm.resources.ResourceSpec;
import edu.utah.janosvm.resources.ResourceSpecException;

public class IllegalStdio
{
    public static void main(String args[])
	throws Exception
    {
	StdioSpec ss = null;
	
	try
	{
	    ResourceSpec rs[] = new ResourceSpec[] {
		ss = new StdioSpec("builtin://none",
				   "file:///foo/bar/baz",
				   "builtin://none"),
	    };
	    
	    Team.create(rs);
	}
	catch(ResourceSpecException e)
	{
	    if( e.getUnsatisfiedSpec() == ss )
	    {
		System.out.println("Bogus stdio spec rejected.");
	    }
	    else
	    {
		System.out.println("Bogus stdio spec rejected, "
				   + "but unsatisfied spec isn't right");
	    }
	}
	
	try
	{
	    new StdioSpec(null, "jsi://", "jsi://");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", null, "jsi://");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", null);
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", "");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", "://");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", "foo://");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", "jsi:/");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", "jsi://foo");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", "builtin://");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", "builtin://foo");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", "file://");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", "fd://");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", "fd://foo");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", ":foo=false:file://1");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
	
	try
	{
	    new StdioSpec("jsi://", "jsi://", ":foo:file://1");
	}
	catch(IllegalArgumentException e)
	{
	    System.out.println("Caught " + e.getMessage());
	}
    }
}

/* Expected Output:
Bogus stdio spec rejected.
Caught inURI can't be null
Caught outURI can't be null
Caught errURI can't be null
Caught Empty protocol in spec: 
Caught Empty protocol in spec: ://
Caught Invalid protocol: foo://
Caught Empty protocol in spec: jsi:/
Caught JSI path should be empty.
Caught Invalid builtin path: 
Caught Invalid builtin path: foo
Caught Empty file path.
Caught Empty fd path.
Caught FD is not a number: foo
Caught Unknown flag: foo=false:file://1
Caught Empty protocol in spec: :foo:file://1
*/
