
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.TeamEvent;
import edu.utah.janosvm.sys.TeamHandle;
import edu.utah.janosvm.sys.EventTeamHandle;

import edu.utah.janosvm.kit.comm.amiga.MsgPort;
import edu.utah.janosvm.kit.comm.amiga.Message;
import edu.utah.janosvm.kit.comm.amiga.SignalSet;

import edu.utah.janosvm.kit.management.team.TeamEventMessage;
import edu.utah.janosvm.kit.management.team.TeamEventMessenger;

public class TeamListTest
{
    public static void main(String args[])
	throws Exception
    {
	Team parent = Team.current();
	SignalSet ss = new SignalSet();
	MsgPort mp = new MsgPort(ss);
	TeamEventMessenger messenger = new TeamEventMessenger(mp);
	long recvMask, waitMask;
	TeamEventMessage tem;
	EventTeamHandle eth;
	int id;

	eth = new EventTeamHandle(messenger);
	Team.create(eth, "Team 1", null);

	eth.switchTo();
	{
	    Team team = Team.current();

	    team.notifyOnFinish();
	    team.addDependency(parent);
	    new Thread(new Runnable() {
		public void run()
		{
		    try { Thread.sleep(100); }
		    catch(InterruptedException e) { }
		    Thread.currentThread().setDaemon(true);
		    while( true );
		}
	    }).start();
	}
	eth.returnFrom();
	tem = (TeamEventMessage)mp.waitForMessage();
	if( (tem.getEvent() == TeamEvent.FINISHED) &&
	    (tem.getHandle() == eth) )
	{
	    System.out.println("Got team finished message");
	}
	else
	{
	    System.out.println("Got a bogus message? " + tem);
	}
	
	eth.terminate();
	
	tem = (TeamEventMessage)mp.waitForMessage();
	if( (tem.getEvent() == TeamEvent.TERMINATED) &&
	    (tem.getHandle() == eth) )
	{
	    System.out.println("Got team termination message");
	}
	else
	{
	    System.out.println("Got a bogus message? " + tem);
	}
	tem = (TeamEventMessage)mp.waitForMessage();
	if( (tem.getEvent() == TeamEvent.DEAD) &&
	    (tem.getHandle() == eth) )
	{
	    System.out.println("Got team dead message");
	}
	else
	{
	    System.out.println("Got a bogus message? " + tem);
	}
	tem = (TeamEventMessage)mp.waitForMessage();
	if( (tem.getEvent() == TeamEvent.BURIED) &&
	    (tem.getHandle() == eth) )
	{
	    System.out.println("Got team buried message");
	}
	else
	{
	    System.out.println("Got a bogus message? " + tem);
	}
    }
}

/* Expected Output:
Got team finished message
Got team termination message
Got team dead message
Got team buried message
*/
