
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.TeamLocal;
import edu.utah.janosvm.sys.TeamHandle;

import edu.utah.janosvm.resources.StdioSpec;
import edu.utah.janosvm.resources.ResourceSpec;

class TeamLocalTest
{
    static TeamLocal myLocal = new TeamLocal() {
	    protected Object initialValue()
	    {
		return new Integer(0);
	    }
	};
    
    public static void main(String args[])
	throws Throwable
    {
	ResourceSpec rs[] = new ResourceSpec[] {
	    StdioSpec.currentFD(),
	};

	Team parent = Team.current();
	TeamHandle th;

	myLocal.set(new Integer(1));
	th = Team.create(rs);
	th.switchTo();
	{
	    Team.current().addDependency(parent);
	    
	    System.out.println("Initial child value = " + myLocal.get());
	    myLocal.set(new Integer(2));
	    System.out.println("New child value = " + myLocal.get());
	}
	th.returnFrom();
	th.terminate();
	System.out.println("Parent value = " + myLocal.get());
    }
}

/* Expected output:
Initial child value = 0
New child value = 2
Parent value = 1
*/
