/*
 * CurrentIsolate.java
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, distribute, and sell this file for
 * any purpose is hereby granted without fee, provided that the above
 * copyright notice is maintained in any derived source code.
 */

import java.lang.isolate.Isolate;
import java.lang.isolate.IsolateMessage;

/**
 * Test various "current-isolate" bits.
 */
public class CurrentIsolate
{
  public static void main(String[] args)
  {
    Isolate self = Isolate.currentIsolate();
    String selfName;

    selfName = self.toString();
    System.out.println("Current Isolate is "
		       + selfName.substring(0, selfName.lastIndexOf('-') + 1));
    
    IsolateMessage[] imsg = self.currentIsolateStartMessages();
    if (imsg == null)
      throw new InternalError("Isolate.currentIsolateStartMessages() should never return null.");
    
    System.out.println(imsg.length + " initial messages:");
    for (int i = 0; i < imsg.length; i++)
    {
      System.out.println("  " +i+ "] " + imsg[i]);
    }

    if (!self.hasStarted())
      throw new InternalError("Root isn't started?");

    if (self.hasExited())
      throw new InternalError("Root has exited?");

    if (self.hasTerminated())
      throw new InternalError("I'm dead?!");

    System.out.println("Done.");

    self.exit(0);
  }
}

// Loader: edu.utah.janosvm.kit.loader.Loader

/* Expected Output:
Current Isolate is Isolate-
0 initial messages:
Done.
*/
