/*
 * IsolateFile.java
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, distribute, and sell this file for
 * any purpose is hereby granted without fee, provided that the above
 * copyright notice is maintained in any derived source code.
 */

import java.lang.isolate.Link;
import java.lang.isolate.Isolate;
import java.lang.isolate.IsolateEvent;
import java.lang.isolate.IsolateMessage;

import java.io.PrintStream;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;

public class IsolateFile
{
  public static void main(String args[])
    throws Throwable
  {
    IsolateMessage startIM[];
    boolean done = false;
    FileInputStream fis1;

    fis1 = new FileInputStream("IsolateFile.class");
    startIM = Isolate.currentIsolateStartMessages();
    if( startIM.length > 0 )
    {
      byte bits1[], bits2[];
      FileInputStream fis2;
      FileOutputStream fos;
      int len1, len2, lpc;
      
      fis2 = startIM[0].getFileInputStream();
      fos = startIM[1].getFileOutputStream();

      bits1 = new byte[1024];
      bits2 = new byte[1024];

      while( !done )
      {
	len1 = fis1.read(bits1);
	len2 = fis2.read(bits2);
	if( len1 == len2 )
	{
	  if( len1 >= 0 )
	  {
	    for( lpc = 0; lpc < len1; lpc++ )
	    {
	      if( bits1[lpc] != bits2[lpc] )
		throw new InternalError("Bits don't match");
	    }
	  }
	  else
	  {
	    done = true;
	  }
	}
	else
	{
	  throw new InternalError("File read lengths don't match");
	}
      }
      new PrintStream(fos).println("Hello World!");
      System.out.println("same");
    }
    else
    {
      Isolate iso = new Isolate("IsolateFile", null);
      FileOutputStream fos;
      BufferedReader br;
      Link elink;

      fos = new FileOutputStream("isofile.out");
      elink = iso.newEventLink();
      iso.start(new IsolateMessage[] {
	IsolateMessage.newFileInputStreamMessage(fis1),
	IsolateMessage.newFileOutputStreamMessage(fos),
      });

      fos.close();

      while( !done )
      {
	IsolateMessage im;
	IsolateEvent ie;
	
	im = elink.receive();
	ie = im.getIsolateEvent();
	if( ie.getType() == IsolateEvent.Type.TERMINATED )
	{
	  done = true;
	}
      }

      br = new BufferedReader(
	new InputStreamReader(new FileInputStream("isofile.out")));
      System.out.println(br.readLine());
    }
  }
}

// Loader: edu.utah.janosvm.kit.loader.Loader

/* Expected Output:
same
Hello World!
*/
