/*
 * TooManyIsolates.java
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, distribute, and sell this file for
 * any purpose is hereby granted without fee, provided that the above
 * copyright notice is maintained in any derived source code.
 */

import java.lang.isolate.Isolate;
import java.lang.isolate.IsolateMessage;
import java.lang.isolate.IsolateResourceError;

import java.util.Vector;

/**
 * Test for IsolateResourceError when too many Isolates have been started.
 */
public class TooManyIsolates
{
  public static void main(String[] args)
    throws Throwable
  {
    if( args.length > 0 )
    {
      Thread.sleep(60 * 1000);
    }
    else
    {
      Vector v = new Vector();
      int lpc, size;
      
      try
      {
	while( true )
	{
	  Isolate iso = new Isolate("TooManyIsolates",
				    new String[] { "foo" },
				    null,
				    null,
				    null,
				    null);
	  
	  v.addElement(iso);
	  iso.start(null);
	}
      }
      catch(IsolateResourceError e)
      {
	System.out.println("Caught resource error.");
      }
      size = v.size();
      for( lpc = 0; lpc < size; lpc++ )
      {
	Isolate iso = (Isolate)v.elementAt(lpc);

	iso.halt(0);
      }
    }
  }
}

// Loader: edu.utah.janosvm.kit.loader.Loader

/* Expected Output:
Caught resource error.
*/
