
import java.util.Hashtable;
import java.util.Enumeration;

import kaffe.sensors.Sensor;
import kaffe.sensors.SensorFeature;

public class SensorsTest
{
    private static boolean verbose = false;
    
    public static void main(String args[])
	throws Throwable
    {
	if( args.length > 0 )
	    verbose = true;

	try
	{
	    Enumeration enum;
	    Hashtable ht;
	    
	    ht = Sensor.detect();
	    enum = ht.elements();
	    while( enum.hasMoreElements() )
	    {
		Enumeration features;
		Sensor sensor;
		
		sensor = (Sensor)enum.nextElement();
		if( verbose )
		{
		    System.out.println("sensor = " + sensor);
		}
		features = sensor.getFeatures();
		while( features.hasMoreElements() )
		{
		    SensorFeature sf;
		    
		    sf = (SensorFeature)features.nextElement();
		    if( verbose )
		    {
			System.out.println("  "
					   + sf.getName()
					   + " = "
					   + sf.read());
		    }
		}
	    }
	    System.out.println("Success");
	}
	catch(UnsatisfiedLinkError e)
	{
	    /* No access... */
	    e.printStackTrace();
	    System.exit(77);
	}
	catch(ExceptionInInitializerError eiie )
	{
	    try
	    {
		throw eiie.getException();
	    }
	    catch(SecurityException e)
	    {
		/* No access... */
		e.printStackTrace();
		System.exit(77);
	    }
	}
    }
}

/* Expected Output:
Success
*/
